;;
;;

(define m17nlib-context-id
  (lambda (mc)
    (car (nthcdr 0 mc))))

(define m17nlib-context-set-id!
  (lambda (mc id)
    (set-car! (nthcdr 0 mc) id)))

(define m17nlib-context-new
  (lambda (name)
    (let ((c ()))
      (set! c (copy-list '(())))
      (m17nlib-context-set-id! c
			       (m17nlib-lib-alloc-context name))
      c)))

(define m17nlib-update-preedit
  (lambda (mc id)
    (let ((mid (m17nlib-context-id mc)))
      (if (m17nlib-lib-preedit-changed? id)
	  (if (m17nlib-lib-compose-mode? id)
	      (begin
		(im-clear-preedit id)
		(im-pushback-preedit id
				     preedit-underline
				     (m17nlib-lib-get-left-of-candidate mid))
		(im-pushback-preedit id
				     (+ preedit-reverse preedit-cursor)
				     (m17nlib-lib-get-selected-candidate mid))
		(im-pushback-preedit id
				     preedit-underline
				     (m17nlib-lib-get-right-of-candidate mid))
		(im-update-preedit id))
	      (begin
		(im-clear-preedit id)
		(im-pushback-preedit id
				     preedit-underline
				     (m17nlib-lib-get-left-of-cursor mid))
		(im-pushback-preedit id
				     preedit-cursor "")
		(im-pushback-preedit id
				     preedit-underline
				     (m17nlib-lib-get-right-of-cursor mid))
		(im-update-preedit id))
	      )))))
; Unfortunatelly, we don't have simple way to translate...
(define m17nlib-translate-ukey-to-mkey
  (lambda (key key-state)
    (cond
     ((= key 'backspace)
      "Backspace")
     ((= key 'delete)
      "Delete")
     ((= key 'escape)
      "Escape")
     ((= key 'return)
      "Return")
     ((= key 'tab)
      "Tab")
     ((= key 'left)
      "Left")
     ((= key 'up)
      "Up")
     ((= key 'right)
      "Right")
     ((= key 'down)
      "Down")
     ((= key 'prior)
      "Page_Down")
     ((= key 'next)
      "Page_Up")
     ((= key 'home)
      "Home")
     ((= key 'end)
      "End")
     ((= key 'zenkaku-hankaku)
      "")
     ((= key 'Multi_key)
      "")
     ((= key 'Mode_switch)
      "")
     ((= key 'Henkan_Mode)
      "")
     ((= key 'Muhenkan)
      "")
     ((= key 'F1)
      "F1")
     ((= key 'F2)
      "F2")
     ((= key 'F3)
      "F3")
     ((= key 'F4)
      "F4")
     ((= key 'F5)
      "F5")
     ((= key 'F6)
      "F6")
     ((= key 'F7)
      "F7")
     ((= key 'F8)
      "F8")
     ((= key 'F9)
      "F9")
     ((= key 'F10)
      "F10")
     ((= key 'F11)
      "F11")
     ((= key 'F12)
      "F12")
     ((= key 'F13)
      "F13")
     ((= key 'F14)
      "F14")
     ((= key 'F15)
      "F15")
     ((= key 'F16)
      "F16")
     ((= key 'F17)
      "F17")
     ((= key 'F18)
      "F18")
     ((= key 'F19)
      "F19")
     ((= key 'F20)
      "F20"))))

(define m17nlib-init-handler
  (lambda (id arg)
    (let* ((c (find-context id)))
      (set-context-data! c (m17nlib-context-new arg)))))

(define m17nlib-release-handler
  (lambda (id)))

(define m17nlib-mode-handler
  (lambda (id mode)))

(define m17nlib-press-key-handler
  (lambda (id key key-state)
    (let* ((c (find-context id))
	   (mc (context-data c))
	   (mid (m17nlib-context-id mc)))
      (if (symbol? key)
	  (let ((mkey (m17nlib-translate-ukey-to-mkey key key-state)))
	    (m17nlib-lib-push-symbol-key mid mkey))
	  (m17nlib-lib-push-key mid key key-state))
      (m17nlib-update-preedit mc id))))

(define m17nlib-release-key-handler
  (lambda (id key key-state)
    ()))

(define m17nlib-reset-handler
  (lambda (id)
    ()))

(define m17nlib-get-candidate-handler
  (lambda (id idx accel-enum-hint)))

(define m17nlib-set-candidate-index-handler
  (lambda (id idx)))

(define m17nlib-prop-handler
  (lambda (id message)))

(define m17nlib-register
  (lambda (i nr-im)
    (if (> nr-im i)
	(begin
	  (register-im
	   (m17nlib-lib-nth-input-method-name i)
	   (m17nlib-lib-nth-input-method-lang i)
	   "UTF-8"
	   (m17nlib-lib-nth-input-method-name i)
	   m17nlib-init-handler
	   m17nlib-release-handler
	   m17nlib-mode-handler
	   m17nlib-press-key-handler
	   m17nlib-release-key-handler
	   m17nlib-reset-handler
	   m17nlib-get-candidate-handler
	   m17nlib-set-candidate-index-handler
	   m17nlib-prop-handler
	   )
	  (m17nlib-register (+ i 1) nr-im))
	())))

(m17nlib-lib-init)
(m17nlib-register 0 (m17nlib-lib-nr-input-methods))
